
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Product_reviewsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const product_reviews = await db.product_reviews.create(
            {
                id: data.id || undefined,
        
        rating: data.rating
        ||
        null
            ,
            
        review_text: data.review_text
        ||
        null
            ,
            
        moderation_status: data.moderation_status
        ||
        null
            ,
            
        reviewed_at: data.reviewed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await product_reviews.setProduct( data.product || null, {
            transaction,
        });
        
        await product_reviews.setBuyer( data.buyer || null, {
            transaction,
        });
        
        await product_reviews.setOrder( data.order || null, {
            transaction,
        });
        
        await product_reviews.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.product_reviews.getTableName(),
                belongsToColumn: 'review_images',
                belongsToId: product_reviews.id,
            },
            data.review_images,
            options,
        );
        

        return product_reviews;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const product_reviewsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                rating: item.rating
            ||
            null
            ,
            
                review_text: item.review_text
            ||
            null
            ,
            
                moderation_status: item.moderation_status
            ||
            null
            ,
            
                reviewed_at: item.reviewed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const product_reviews = await db.product_reviews.bulkCreate(product_reviewsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < product_reviews.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.product_reviews.getTableName(),
                    belongsToColumn: 'review_images',
                    belongsToId: product_reviews[i].id,
                },
                data[i].review_images,
                options,
            );
        }
        

        return product_reviews;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const product_reviews = await db.product_reviews.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.rating !== undefined) updatePayload.rating = data.rating;
        
        
        if (data.review_text !== undefined) updatePayload.review_text = data.review_text;
        
        
        if (data.moderation_status !== undefined) updatePayload.moderation_status = data.moderation_status;
        
        
        if (data.reviewed_at !== undefined) updatePayload.reviewed_at = data.reviewed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await product_reviews.update(updatePayload, {transaction});

        
        
        if (data.product !== undefined) {
            await product_reviews.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.buyer !== undefined) {
            await product_reviews.setBuyer(
              
              data.buyer,
              
              { transaction }
            );
        }
        
        if (data.order !== undefined) {
            await product_reviews.setOrder(
              
              data.order,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await product_reviews.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.product_reviews.getTableName(),
                belongsToColumn: 'review_images',
                belongsToId: product_reviews.id,
            },
            data.review_images,
            options,
        );
        

        return product_reviews;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const product_reviews = await db.product_reviews.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of product_reviews) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of product_reviews) {
                await record.destroy({transaction});
            }
        });


        return product_reviews;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const product_reviews = await db.product_reviews.findByPk(id, options);

        await product_reviews.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await product_reviews.destroy({
            transaction
        });

        return product_reviews;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const product_reviews = await db.product_reviews.findOne(
            { where },
            { transaction },
        );

        if (!product_reviews) {
            return product_reviews;
        }

        const output = product_reviews.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.product = await product_reviews.getProduct({
            transaction
        });
        
        
        output.buyer = await product_reviews.getBuyer({
            transaction
        });
        
        
        output.order = await product_reviews.getOrder({
            transaction
        });
        
        
        output.review_images = await product_reviews.getReview_images({
            transaction
        });
        
        
        output.organizations = await product_reviews.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              product_name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'buyer',
        
        where: filter.buyer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.buyer.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.buyer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.orders,
        as: 'order',
        
        where: filter.order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'review_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.review_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'product_reviews',
                        'review_text',
                        filter.review_text,
                    ),
                };
            }
            

            
            

            
            if (filter.ratingRange) {
                const [start, end] = filter.ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reviewed_atRange) {
                const [start, end] = filter.reviewed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reviewed_at: {
                    ...where.reviewed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reviewed_at: {
                    ...where.reviewed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.moderation_status) {
                where = {
                    ...where,
                moderation_status: filter.moderation_status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.product_reviews.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'product_reviews',
                        'review_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.product_reviews.findAll({
            attributes: [ 'id', 'review_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['review_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.review_text,
        }));
    }

    
};

